/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.electronicshop.client.app;

import it.electronicshop.ejb.beans.requestRemote;
import it.electronicshop.ejb.util.CartDetails;
import it.electronicshop.ejb.util.CartItemDetails;
import it.electronicshop.ejb.util.ProductDetails;
import it.electronicshop.ejb.util.ProducttypeDetails;
import it.electronicshop.ejb.util.UserClientDetails;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.LinkedList;
import javax.ejb.EJB;

/**
 *
 * @author boymixli
 */
public class ElectronicShopManagement {

    /* Model */
    @EJB
    private static requestRemote rb;
    private static UserClientDetails userClient;
    private static ProducttypeDetails productType;
    private static ProductDetails product;

    /* Functions Viewer */
    private enum Menu {

        LOGIN, WELCOME, WELCOMELOGGED, EXITNOW,
        M_MAIN,
            M_USER,
                M_USER_INS, M_USER_DEL, M_USER_MOD, M_USER_VIS,
            M_PRODUCT,
                M_PRODUCT_INS, M_PRODUCT_DEL, M_PRODUCT_MOD, M_PRODUCT_VIS, M_PRODUCT_VIS_SPEC_TYPE,
            M_TYPE_PRODUCT,
                M_TYPE_PRODUCT_INS, M_TYPE_PRODUCT_DEL, M_TYPE_PRODUCT_MOD, M_TYPE_PRODUCT_VIS,
            M_CART,
                M_CART_VIS
    }
    private static HashMap<Menu, LinkedList<Menu>> menus;
    private static HashMap<Menu, String> menulabels;
    private static HashMap<Menu, Menu> menuParents;
    private static String exitKey = "|";
    private static String backKey = "<";

    private static void loadMenus() {
        menus = new HashMap<Menu, LinkedList<Menu>>();
        menulabels = new HashMap<Menu, String>();
        menuParents = new HashMap<Menu, Menu>();

        // M_MAIN
        LinkedList<Menu> subM = new LinkedList<Menu>();

        LinkedList<Menu> tmp = new LinkedList<Menu>();

        /* Users */
        tmp.add(Menu.M_USER_INS);
        menulabels.put(Menu.M_USER_INS, "Inserisci nuovo utente");
        menuParents.put(Menu.M_USER_INS, Menu.M_USER);

        tmp.add(Menu.M_USER_DEL);
        menulabels.put(Menu.M_USER_DEL, "Cancella utente");
        menuParents.put(Menu.M_USER_DEL, Menu.M_USER);

        tmp.add(Menu.M_USER_MOD);
        menulabels.put(Menu.M_USER_MOD, "Modifica utente");
        menuParents.put(Menu.M_USER_MOD, Menu.M_USER);

        tmp.add(Menu.M_USER_VIS);
        menulabels.put(Menu.M_USER_VIS, "Utenti attuali");
        menuParents.put(Menu.M_USER_VIS, Menu.M_USER);

        menus.put(Menu.M_USER, tmp);
        subM.add(Menu.M_USER);
        menulabels.put(Menu.M_USER, "Menu utenti");
        menuParents.put(Menu.M_USER, Menu.M_MAIN);

        /* Tipi di prodotti */
        tmp = new LinkedList<Menu>();
        tmp.add(Menu.M_TYPE_PRODUCT_INS);
        menulabels.put(Menu.M_TYPE_PRODUCT_INS, "Inserisci nuovo tipo di prodotto");
        menuParents.put(Menu.M_TYPE_PRODUCT_INS, Menu.M_TYPE_PRODUCT);

        tmp.add(Menu.M_TYPE_PRODUCT_DEL);
        menulabels.put(Menu.M_TYPE_PRODUCT_DEL, "Cancella tipo di prodotto");
        menuParents.put(Menu.M_TYPE_PRODUCT_DEL, Menu.M_TYPE_PRODUCT);

        tmp.add(Menu.M_TYPE_PRODUCT_MOD);
        menulabels.put(Menu.M_TYPE_PRODUCT_MOD, "Modifica tipo di prodotto");
        menuParents.put(Menu.M_TYPE_PRODUCT_MOD, Menu.M_TYPE_PRODUCT);

        tmp.add(Menu.M_TYPE_PRODUCT_VIS);
        menulabels.put(Menu.M_TYPE_PRODUCT_VIS, "Tipi di prodotti attuali");
        menuParents.put(Menu.M_TYPE_PRODUCT_VIS, Menu.M_TYPE_PRODUCT);

        menus.put(Menu.M_TYPE_PRODUCT, tmp);
        subM.add(Menu.M_TYPE_PRODUCT);
        menulabels.put(Menu.M_TYPE_PRODUCT, "Menu tipi di prodotti");
        menuParents.put(Menu.M_TYPE_PRODUCT, Menu.M_MAIN);

        /* Prodotti */
        tmp = new LinkedList<Menu>();
        tmp.add(Menu.M_PRODUCT_INS);
        menulabels.put(Menu.M_PRODUCT_INS, "Inserisci nuovo prodotto");
        menuParents.put(Menu.M_PRODUCT_INS, Menu.M_PRODUCT);

        tmp.add(Menu.M_PRODUCT_DEL);
        menulabels.put(Menu.M_PRODUCT_DEL, "Cancella prodotto");
        menuParents.put(Menu.M_PRODUCT_DEL, Menu.M_PRODUCT);

        tmp.add(Menu.M_PRODUCT_MOD);
        menulabels.put(Menu.M_PRODUCT_MOD, "Modifica prodotto");
        menuParents.put(Menu.M_PRODUCT_MOD, Menu.M_PRODUCT);

        tmp.add(Menu.M_PRODUCT_VIS);
        menulabels.put(Menu.M_PRODUCT_VIS, "Prodotti attuali");
        menuParents.put(Menu.M_PRODUCT_VIS, Menu.M_PRODUCT);

        tmp.add(Menu.M_PRODUCT_VIS_SPEC_TYPE);
        menulabels.put(Menu.M_PRODUCT_VIS_SPEC_TYPE, "Visualizza prodotti di un particolare tipo");
        menuParents.put(Menu.M_PRODUCT_VIS_SPEC_TYPE, Menu.M_PRODUCT);

        menus.put(Menu.M_PRODUCT, tmp);
        subM.add(Menu.M_PRODUCT);
        menulabels.put(Menu.M_PRODUCT, "Menu prodotti");
        menuParents.put(Menu.M_PRODUCT, Menu.M_MAIN);

        /* Carrelli salvati */
        tmp = new LinkedList<Menu>();
        tmp.add(Menu.M_CART_VIS);
        menulabels.put(Menu.M_CART_VIS, "Visualizza singolo carrello");
        menuParents.put(Menu.M_CART_VIS, Menu.M_CART);

        menus.put(Menu.M_CART, tmp);
        subM.add(Menu.M_CART);
        menulabels.put(Menu.M_CART, "Menu carrelli");
        menuParents.put(Menu.M_CART, Menu.M_MAIN);


        menulabels.put(Menu.M_MAIN, "Menu principale");
        menus.put(Menu.M_MAIN, subM);

        // System.out.println(menus);
    }

    private static void visualMenu(Menu type) {
        System.out.println("###### Amministrazione dell' Electronic Shop  #####");
        switch (type) {
            case WELCOME: {
                System.out.println("Benvenuto nel tool di amministrazione dell' Electronic Shop");
                break;
            }
            case LOGIN: {
                System.out.println("E' necessaria l'autenticazione");
                System.out.println("Premere '" + exitKey + "' per uscire");
                break;
            }
            case WELCOMELOGGED: {
                System.out.println("Benvenuto Amministratore sei entrato nel sistema");
                break;
            }
            case EXITNOW: {
                System.out.println("Spiacenti, il programma termina qui");
                break;
            }
        }
        System.out.println("##################################################");
    }

    private static Menu chooseMenu(Menu startM) {
        Menu endM = null;
        LinkedList<Menu> sumB = visualMultiMenu(startM);
        String insert = "";
        boolean replayLoop = true;
        do {

            insert = getInput("Scelta:", false);
            if (!insert.equals(exitKey)) {
                if (!insert.equals(backKey)) {
                    try {
                        int choose = Integer.parseInt(insert);
                        if (choose < sumB.size()) {
                            replayLoop = false;
                            endM = sumB.get(choose);
                        }
                    } catch (Exception ei) {
                    }
                    if (replayLoop) {
                        System.err.println("Scelta non valida: " + insert);
                    }
                } else {
                    endM = menuParents.get(startM);
                    if (endM.equals(startM)) {
                        endM = Menu.M_MAIN;
                    }
                    replayLoop = false;
                }
            } else {
                exitNow();
            }
        } while (replayLoop);
        return endM;
    }

    private static LinkedList<Menu> visualMultiMenu(Menu startM) {
        LinkedList<Menu> subM = menus.get(startM);
        if (subM == null) {
            startM = menuParents.get(startM);
            subM = menus.get(startM);
        }
        System.out.println("###### " + menulabels.get(startM) + "  #####");
        int pos = 0;
        for (Menu menu : subM) {

            System.out.println(pos + " - " + menulabels.get(menu));
            pos++;
        }
        System.out.println("'" + backKey + "' - Menu precedente");
        System.out.println("'" + exitKey + "' - Esci");
        System.out.println("##################################################");
        return subM;
    }

    /* Functions controller */
    private static void executeMenu(Menu m) throws Exception {

        switch (m) {
            case M_USER: {
                executeMenu(Menu.M_USER_VIS);
                break;
            }
            case M_USER_DEL: {
                executeMenu(Menu.M_USER_VIS);
                Integer userId = new Integer(getInput("Inserire l'ID utente da cancellare:", false));
                userClient = rb.findUserClient(userId);
                rb.removeUserClient(userClient);
                System.out.println("Utente cancellato");
                break;
            }

            case M_USER_VIS: {
                System.out.println(">>>>>> " + menulabels.get(m));
                System.out.println(
                            "IdUser" + "\t|" +
                            "Name" + "\t|" +
                            "Password" + "\t|" +
                            "IsAdmin");

                for (UserClientDetails u : rb.findAllUserClients()) {
                    System.out.println(
                            u.getIdUser() + "\t|" +
                            u.getName() + "\t|" +
                            u.getPassword() + "\t|" +
                            u.getIsAdmin());
                }
                break;
            }
            case M_USER_MOD: {
                executeMenu(Menu.M_USER_VIS);
                Integer userId = new Integer(getInput("Inserire l'ID utente da modificare:", false));

                userClient = rb.findUserClient(userId);

                System.out.println("Inserire i nuovi dati, premi solo INVIO per lasciare il valore vecchio []");
                userClient.setName(getInput("Nome [" + userClient.getName() + "]:", true, userClient.getName()));
                userClient.setPassword(getInput("Password [" + userClient.getPassword() + "]:", true, userClient.getPassword()));
                userClient.setIsAdmin(Integer.parseInt(getInput("Amministratore? 1 Si, 0 No [" + userClient.getIsAdmin() + "]:",
                        true,
                        Integer.valueOf(userClient.getIsAdmin()).toString())));

                rb.editUserClient(userClient);
                System.out.println("Utente modificato");
                break;
            }
            case M_USER_INS: {
                System.out.println(">>>>>> " + menulabels.get(m));
                userClient = new UserClientDetails(
                        null,
                        getInput("Nome:", false),
                        getInput("Password:", true),
                        Integer.parseInt(getInput("Amministratore? 1 Si, 0 No:", false)),
                        null);
                rb.createUserClient(userClient);
                System.out.println("Utente inserito");
                break;
            }
            case M_TYPE_PRODUCT: {
                executeMenu(Menu.M_TYPE_PRODUCT_VIS);
                break;
            }
            case M_TYPE_PRODUCT_VIS: {
                System.out.println(">>>>>> " + menulabels.get(m));
                System.out.println(
                            "IdType" + "\t|" +
                            "NameType" + "\t|" +
                            "DescriptionType");
                for (ProducttypeDetails pt : rb.findAllProducttypes()) {
                    System.out.println(
                            pt.getIdType() + "\t|" +
                            pt.getNameType() + "\t|" +
                            pt.getDescriptionType());
                }
                break;
            }

            case M_TYPE_PRODUCT_INS: {
                System.out.println(">>>>>> " + menulabels.get(m));
                productType = new ProducttypeDetails(
                        null,
                        getInput("Nome:", false),
                        getInput("Descrizione:", true));
                rb.createProducttype(productType);
                System.out.println("Tipo prodotto inserito");
                break;
            }
            case M_TYPE_PRODUCT_DEL: {
                executeMenu(Menu.M_TYPE_PRODUCT_VIS);
                Integer typeProdId = new Integer(getInput("Inserire l'ID tipo prodotto da cancellare:", false));
                productType = rb.findProducttype(typeProdId);

                rb.removeProducttype(productType);
                System.out.println("Tipo prodotto cancellato");
                break;
            }
            case M_TYPE_PRODUCT_MOD: {
                executeMenu(Menu.M_TYPE_PRODUCT_VIS);
                Integer typeProdId = new Integer(getInput("Inserire l'ID tipo prodotto da modificare:", false));
                productType = rb.findProducttype(typeProdId);

                System.out.println("Inserire i nuovi dati, premi solo INVIO per lasciare il valore vecchio []");
                productType.setNameType(getInput("Nome [" + productType.getNameType() + "]:", true, productType.getNameType()));
                productType.setDescriptionType(getInput("Descrizione [" + productType.getDescriptionType() + "]:", true, productType.getDescriptionType()));

                rb.editProducttype(productType);
                System.out.println("Tipo prodotto modificato");
                break;
            }

            case M_PRODUCT: {
                executeMenu(Menu.M_PRODUCT_VIS);
                break;
            }
            case M_PRODUCT_VIS: {
                System.out.println(">>>>>> " + menulabels.get(m));
                System.out.println(
                            "IdProduct" + "\t|" +
                            "NameProduct" + "\t|" +
                            "DescProduct" + "\t|" +
                            "NameType" + "\t|" +
                            "Prize" + "\t|" +
                            "Quantity");
                for (ProductDetails p : rb.findAllProducts()) {
                    System.out.println(
                            p.getIdProduct() + "\t|" +
                            p.getNameProduct() + "\t|" +
                            p.getDescProduct() + "\t|" +
                            p.getPtD().getNameType() + "\t|" +
                            p.getPrize() + "\t|" +
                            p.getQuantity());
                }
                break;
            }
            case M_PRODUCT_INS: {
                System.out.println(">>>>>> " + menulabels.get(m));
                if (rb.findAllProducttypes().size() > 0) {
                    executeMenu(Menu.M_TYPE_PRODUCT_VIS);
                    Integer typeProdId = new Integer(getInput("Inserire l'ID tipo prodotto del nuovo prodotto:", false));
                    ProducttypeDetails pd = rb.findProducttype(typeProdId);
                    product = new ProductDetails(
                            null,
                            getInput("Nome:", false),
                            getInput("Descrizione:", true),
                            Float.parseFloat(getInput("Prezzo:", true)),
                            Integer.parseInt(getInput("Quantità:", true)),
                            pd);
                    rb.createProduct(product);
                    System.out.println("Prodotto inserito");
                } else {
                    throw new Exception("Attenzione è necessario che ci sia almeno un tipo di prodotto per inserire un prodotto!");
                }
                break;
            }
            case M_PRODUCT_DEL: {
                executeMenu(Menu.M_PRODUCT_VIS);
                Integer prodId = new Integer(getInput("Inserire l'ID prodotto da cancellare:", false));
                product = rb.findProduct(prodId);

                rb.removeProduct(product);
                System.out.println("Prodotto cancellato");
                break;
            }
            case M_PRODUCT_MOD: {
                executeMenu(Menu.M_PRODUCT_VIS);
                Integer prodId = new Integer(getInput("Inserire l'ID prodotto da modificare:", false));
                product = rb.findProduct(prodId);

                System.out.println("Inserire i nuovi dati, premi solo INVIO per lasciare il valore vecchio []");
                product.setNameProduct(getInput("Nome [" + product.getNameProduct() + "]:", true, product.getNameProduct()));
                product.setDescProduct(getInput("Descrizione [" + product.getDescProduct() + "]:", true, product.getDescProduct()));
                executeMenu(Menu.M_TYPE_PRODUCT_VIS);
                product.setIdType(Integer.parseInt(getInput("Inserire l'ID tipo prodotto [" + product.getIdType() + "]:", true, Integer.toString(product.getIdType()))));
                product.setPrize(Float.parseFloat(getInput("Prezzo [" + product.getPrize() + "]:", true, Float.toString(product.getPrize()))));
                product.setQuantity(Integer.parseInt(getInput("Quantità [" + product.getQuantity() + "]:", true, Integer.toString(product.getQuantity()))));

                rb.editProduct(product);
                System.out.println("Prodotto modificato");
                break;
            }

            case M_PRODUCT_VIS_SPEC_TYPE: {
                System.out.println(">>>>>> " + menulabels.get(m));
                executeMenu(Menu.M_TYPE_PRODUCT_VIS);
                Integer prodTypeId = new Integer(getInput("Inserire l'ID del tipo prodotto:", false));
                System.out.println(
                            "IdProduct" + "\t|" +
                            "NameProduct" + "\t|" +
                            "DescProduct" + "\t|" +
                            "NameType" + "\t|" +
                            "Prize" + "\t|" +
                            "Quantity");

                for (ProductDetails p : rb.findAllProductsByType(prodTypeId)) {
                    System.out.println(
                            p.getIdProduct() + "\t|" +
                            p.getNameProduct() + "\t|" +
                            p.getDescProduct() + "\t|" +
                            p.getPtD().getNameType() + "\t|" +
                            p.getPrize() + "\t|" +
                            p.getQuantity());
                }
                break;
            }
            case M_CART_VIS: {
                executeMenu(Menu.M_USER_VIS);
                Integer userId = new Integer(getInput("Inserire l'ID utente del carrello da visualizzare:", false));
                System.out.println(
                            "NameProduct"   + "\t|" +
                            "Request");
                userClient = rb.findUserClient(userId);
                CartDetails cd = userClient.getCart();
                for (CartItemDetails cid : cd.getItems()) {
                    System.out.println(
                            cid.getProduct().getNameProduct()   + "\t|" +
                            cid.getRequest());
                }
                break;
            }
        }
    }

    private static void exitNow() {
        visualMenu(Menu.EXITNOW);
        System.exit(1);
    }

    private static void login() {
        String insert = "";
        String user = "";
        String password = "";
        boolean replayLoop = true;
        do {
            visualMenu(Menu.LOGIN);
            insert = getInput("Username:", false);
            if (!insert.equals(exitKey)) {
                user = insert;
                insert = getInput("Password:", false);
                if (!insert.equals(exitKey)) {
                    password = insert;
                } else {
                    exitNow();
                }
            } else {
                exitNow();
            }
            replayLoop = !rb.isUserLoggedAdmin(user, password);
        } while (replayLoop);
    }

    public static void main(String[] args) {
        loadMenus();
        visualMenu(Menu.WELCOME);
        login();
        visualMenu(Menu.WELCOMELOGGED);
        Menu m = Menu.M_MAIN;
        while (true) {
            try {
                m = chooseMenu(m);
                executeMenu(m);
            } catch (Exception e) {
                System.err.println("Attenzione si è verificato un errore: ");
                e.printStackTrace();
            }
        }
    }

    private static String getInput(String label, boolean empty) {

        return getInput(label, empty, "");
    }

    private static String getInput(String label, boolean empty, String def) {
        String s = "";
        boolean cont = true;
        do {
            InputStreamReader reader = new InputStreamReader(System.in);
            BufferedReader buf_reader = new BufferedReader(reader);
            try {
                System.out.print(label + " ");
                s = buf_reader.readLine();
                if (s.equals("") && !empty) {
                    System.err.println("Il campo non può essere vuoto");
                } else {
                    // default value
                    if (s.equals("")) {
                        s = def;
                    }
                    cont = false;
                }
            } catch (Exception e) {
                System.err.println("Attenzione si è verificato un errore:");
                e.printStackTrace();
            }
        } while (cont);
        return s;
    }
}
