/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.electronicshop.ejb.beans;

import it.electronicshop.ejb.util.CartDetails;
import it.electronicshop.ejb.util.CartItemDetails;
import it.electronicshop.ejb.util.ProductDetails;
import it.electronicshop.ejb.util.UserClientDetails;
import java.util.LinkedList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.PostActivate;
import javax.ejb.PrePassivate;
import javax.ejb.Remote;
import javax.ejb.Remove;
import javax.ejb.Stateless;

/**
 *
 * @author boymixli
 */
@Stateless
@Remote(cartControllerRemote.class)
public class cartControllerBean implements cartControllerRemote {

    private UserClientDetails ucd;

    @Override
    public UserClientDetails getUcd() {
        return ucd;
    }

    @Override
    public void setUcd(UserClientDetails ucd) {
        this.ucd = ucd;
    }

    @Override
    public void inizialize(UserClientDetails ucd) {
        this.ucd = ucd;
    }

    @Override
    public void addProductToCart(ProductDetails p, Integer q) {
        this.ucd.getCart().addItem(new CartItemDetails(p,q));
    }

    @Override
    public void removeProductsCart(Integer idP) {
        this.ucd.getCart().delItemById(idP);
    }

    @Override
    public List<CartItemDetails> getProductsFromCart() {
        if(this.ucd != null && this.ucd.getCart() != null)
        {
            return this.ucd.getCart().getItems();
        }
        else
        {
            return null;
        }
    }

    @Override
    public String updateQuantityCart(Integer idProduct, int request) {
        String e = "";
        for (CartItemDetails cd : this.ucd.getCart().getItems()) {
            if(cd.getProduct().getIdProduct().equals(idProduct))
            {
                cd.setRequest(request);
                break;
            }
        }
        return e;
    }
    @Override
    public CartItemDetails getProductCartById(Integer idProduct) {
        for (CartItemDetails cd : this.ucd.getCart().getItems()) {
            if(cd.getProduct().getIdProduct().equals(idProduct))
            {
                return cd;
            }
        }
        return null;
    }

    @Override
    public void setProductCartById(CartItemDetails cd)
    {
        for (CartItemDetails cdIn : this.ucd.getCart().getItems()) {
            if(cdIn.getProduct().getIdProduct().equals(cd.getProduct().getIdProduct()))
            {
                int i = this.ucd.getCart().getItems().indexOf(cdIn);
                this.ucd.getCart().getItems().set(i,cd);
                break;
            }
        }
    }

    @Override
    public void loadCart(CartDetails cart) {
        this.ucd.setCart(cart);
    }

    @Override
    public void destroite() {
        ucd = null;
    }

    @Override
    public void cleanCart() {
         List<CartItemDetails> lc = new LinkedList<CartItemDetails>();
         CartDetails cd = new CartDetails(ucd, lc);
         ucd.setCart(cd);
    }

    @Remove
    public void remove() {
        ucd = null;
    }

    @PostConstruct
    public void postCostruct(){
    }

    @PreDestroy
    public void preDestroy(){
    }

    @PostActivate
    public void postActivate(){
    }

    @PrePassivate
    public void prePassivate(){
    }

}
