/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.electronicshop.ejb.beans;

import it.electronicshop.ejb.entities.CartItem;
import it.electronicshop.ejb.entities.Product;
import it.electronicshop.ejb.entities.Producttype;
import it.electronicshop.ejb.entities.UserClient;
import it.electronicshop.ejb.util.CartDetails;
import it.electronicshop.ejb.util.CartItemDetails;
import it.electronicshop.ejb.util.ProductDetails;
import it.electronicshop.ejb.util.ProducttypeDetails;
import it.electronicshop.ejb.util.UserClientDetails;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author boymixli
 */
@Stateless
@Remote(requestRemote.class)
public class requestBean implements requestRemote {

    @PersistenceContext
    private EntityManager esem;

    /* Client User */
    @Override
    public void createUserClient(UserClientDetails UserClientD) {
        UserClient u = new UserClient(UserClientD.getIdUser(),UserClientD.getName(),UserClientD.getPassword(),UserClientD.getIsAdmin());
        esem.persist(u);
    }

    @Override
    public void editUserClient(UserClientDetails UserClientD) {
        UserClient u = new UserClient(UserClientD.getIdUser(),UserClientD.getName(),UserClientD.getPassword(),UserClientD.getIsAdmin());
        esem.merge(u);
    }

    public boolean isLoggedAdmin(String user, String password) {
        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    public void removeUserClient(UserClientDetails UserClientD) {
        UserClient u = esem.find(UserClient.class, UserClientD.getIdUser());
        esem.remove(u);
    }

    @Override
    public UserClientDetails findUserClient(Object id) {
        UserClient u = esem.find(UserClient.class, id);
        UserClientDetails uD = new UserClientDetails(u.getIdUser(),u.getName(),u.getPassword(),u.getIsAdmin(),copyCartItemsToCartDetails(u.getCartItems()));
        return uD;
    }

    @Override
    public List<UserClientDetails> findAllUserClients() {
        
        return copyUsersToDetails(esem.createNamedQuery("it.electronicshop.ejb.entities.UserClient.findAll").getResultList());
    }

    @Override
    public boolean isUserLoggedAdmin(String user, String password) {
        List resultList = esem.createNamedQuery("it.electronicshop.ejb.entities.UserClient.findAdminUser").setParameter("name", user).setParameter("password", password).getResultList();
        return (resultList != null && resultList.size() > 0);
    }

    @Override
    public UserClientDetails GetUserLogged(String user, String password) {
        List resultList = esem.createNamedQuery("it.electronicshop.ejb.entities.UserClient.findUserByPass").setParameter("name", user).setParameter("password", password).getResultList();
        if(resultList != null && resultList.size() > 0)
        {
            UserClient c = (UserClient)resultList.get(0);
            UserClientDetails ucd = new UserClientDetails(c.getIdUser(), c.getName(), c.getPassword(), c.getIsAdmin(),copyCartItemsToCartDetails(c.getCartItems()));
            return ucd;
        }
        else
            return null;
    }

    private List<UserClientDetails> copyUsersToDetails(List<UserClient> clients) {
        List<UserClientDetails> detailsList = new ArrayList<UserClientDetails>();
        for(UserClient c : clients)
        {
            UserClientDetails ucd = new UserClientDetails(c.getIdUser(), c.getName(), c.getPassword(), c.getIsAdmin(),copyCartItemsToCartDetails(c.getCartItems()));
            detailsList.add(ucd);
        }
        return detailsList;
    }

    /* Product type */
    @Override
    public void createProducttype(ProducttypeDetails producttypeD) {
        Producttype producttype = new Producttype(producttypeD.getIdType(),producttypeD.getNameType(),producttypeD.getDescriptionType());
        esem.persist(producttype);
    }

    @Override
    public void editProducttype(ProducttypeDetails producttypeD) {
        Producttype producttype = new Producttype(producttypeD.getIdType(),producttypeD.getNameType(),producttypeD.getDescriptionType());
        esem.merge(producttype);
    }

    @Override
    public void removeProducttype(ProducttypeDetails producttypeD) {
        Producttype producttype = esem.find(Producttype.class, producttypeD.getIdType());
        esem.remove(producttype);
    }
    
    @Override
    public ProducttypeDetails findProducttype(Object id) {
        Producttype pt = esem.find(Producttype.class, id);
        ProducttypeDetails ptD = new ProducttypeDetails(pt.getIdType(), pt.getNameType(),pt.getDescriptionType());
        return ptD;
    }
    
    private List<ProducttypeDetails> copyProductTypeToDetails(List<Producttype> producttypes) {
        List<ProducttypeDetails> detailsList = new ArrayList<ProducttypeDetails>();
        for(Producttype pt : producttypes)
        {
            ProducttypeDetails ptD = new ProducttypeDetails(pt.getIdType(), pt.getNameType(),pt.getDescriptionType());
            detailsList.add(ptD);

        }
        return detailsList;
    }

    @Override
    public List<ProducttypeDetails> findAllProducttypes() {
        return copyProductTypeToDetails(esem.createNamedQuery("it.electronicshop.ejb.entities.Producttype.findAll").getResultList());
    }

    /* Product */
    @Override
    public void createProduct(ProductDetails productD) {
        Product product = new Product(productD.getIdProduct(),productD.getNameProduct(),productD.getDescProduct(),productD.getPrize(), productD.getQuantity(), productD.getIdType());
        esem.persist(product);
    }

    @Override
    public void editProduct(ProductDetails productD) {
        Product product = new Product(productD.getIdProduct(),productD.getNameProduct(),productD.getDescProduct(),productD.getPrize(), productD.getQuantity(), productD.getIdType());
        esem.merge(product);
    }

    @Override
    public void removeProduct(ProductDetails productD) {
        Product product = esem.find(Product.class, productD.getIdProduct());
        esem.remove(product);
    }

    @Override
    public ProductDetails findProduct(Object id) {
        Product p = esem.find(Product.class, id);
        ProducttypeDetails ptd = findProducttype(p.getIdType());
        ProductDetails pD = new ProductDetails(p.getIdProduct(),p.getNameProduct(),p.getDescProduct(),p.getPrize(), p.getQuantity(), ptd);
        return pD;
    }

    private List<ProductDetails> copyProductToDetails(List<Product> products) {
        List<ProductDetails> detailsList = new ArrayList<ProductDetails>();
        for(Product p : products)
        {
            Producttype pt = p.getProductType();
            ProducttypeDetails ptD = new ProducttypeDetails(pt.getIdType(), pt.getNameType(),pt.getDescriptionType());
            ProductDetails pD = new ProductDetails(p.getIdProduct(),p.getNameProduct(),p.getDescProduct(),p.getPrize(), p.getQuantity(), ptD);

            detailsList.add(pD);

        }
        return detailsList;
    }

    @Override
    public List<ProductDetails> findAllProductsByType(Object id) {
        Producttype pt = esem.find(Producttype.class, id);
        return copyProductToDetails(pt.getProducts());
    }

    @Override
    public List<ProductDetails> findAllProducts() {
        return copyProductToDetails(esem.createNamedQuery("it.electronicshop.ejb.entities.Product.findAll").getResultList());
    }
    
    /* Cart */
    @Override
    public void createCart(CartDetails cartD) {
        for(CartItemDetails cid : cartD.getItems())
        {
            CartItem cart = new CartItem(cartD.getIdUser(),cid.getProduct().getIdProduct(),cid.getRequest());
            esem.persist(cart);
        }
    }

    @Override
    public void editCart(CartDetails cartD) {
        //Clear Product
        removeCart(cartD.getIdUser());
        for(CartItemDetails cid : cartD.getItems())
        {
            CartItem cart = new CartItem(cartD.getIdUser(),cid.getProduct().getIdProduct(),cid.getRequest());
            esem.persist(cart);
        }
    }

    @Override
    public void removeCart(Integer userCart) {
        CartDetails cart = findCartByClient(userCart);
        for(CartItemDetails cid : cart.getItems())
        {
            // Pass if item cart not exit
            try{
                CartItem cartI = esem.find(CartItem.class, cid.getIdCartItem());
                if(cartI != null)
                {
                    esem.remove(cartI);
                }
            }
            catch (Exception ec){}
            
        }
    }

    private CartDetails copyCartItemsToCartDetails(List<CartItem> carts) {
        
        List<CartItemDetails> detailsList = new ArrayList<CartItemDetails>();
        Integer client = -1;
        for(CartItem ci : carts)
        {
            client = ci.getIdUser();
            CartItemDetails cid = new CartItemDetails(ci.getIdCartItem(),findProduct(ci.getProduct().getIdProduct()), ci.getRequest());
            detailsList.add(cid);

        }
        return new CartDetails(client, detailsList);
    }

    public List<UserClientDetails> findClientsWithCart() {
        return copyUsersToDetails(esem.createNamedQuery("it.electronicshop.ejb.entities.CartItem.findAllClient").getResultList());
    }

    @Override
    public CartDetails findCartByClient(Integer id) {
        return copyCartItemsToCartDetails(esem.createNamedQuery("it.electronicshop.ejb.entities.CartItem.findByIdUser").setParameter("idUser", id).getResultList());
    }
}
