/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.electronicshop.ejb.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 *
 * @author boymixli
 */
@Entity
@Table(name = "CartItem", catalog = "electronicshop", schema = "")
@NamedQueries({
    @NamedQuery(name = "it.electronicshop.ejb.entities.CartItem.findAll", query = "SELECT c FROM CartItem c"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.CartItem.findByIdCartItem", query = "SELECT c FROM CartItem c WHERE c.idCartItem = :idCartItem"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.CartItem.findByIdUser", query = "SELECT c FROM CartItem c WHERE c.idUser = :idUser"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.CartItem.findByIdProduct", query = "SELECT c FROM CartItem c WHERE c.idProduct = :idProduct"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.CartItem.findAllClient", query = "SELECT DISTINCT u FROM UserClient u JOIN u.cartItems"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.CartItem.findByRequest", query = "SELECT c FROM CartItem c WHERE c.request = :request")})

public class CartItem implements Serializable {
    private static final long serialVersionUID = 1L;

    @Id
    @Basic(optional = false)
    @Column(name = "idCartItem", nullable = true)
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private Integer idCartItem;

    public Integer getIdCartItem() {
        return idCartItem;
    }

    public void setIdCartItem(Integer idCartItem) {
        this.idCartItem = idCartItem;
    }

    public Integer getIdUser() {
        return idUser;
    }

    public void setIdUser(Integer idUser) {
        this.idUser = idUser;
    }

    @Basic(optional = false)
    @Column(name = "idUser", nullable = false)
    private Integer idUser;
    
    @JoinColumn(name = "idUser", referencedColumnName= "idUser", insertable=false, updatable=false)
    @ManyToOne
    private UserClient client;

    public UserClient getClient() {
        return client;
    }

    public void setClient(UserClient client) {
        this.client = client;
    }

    @Basic(optional = false)
    @Column(name = "idProduct", nullable = false)
    private Integer idProduct;
    
    @JoinColumn(name = "idProduct", referencedColumnName= "idProduct", insertable=false, updatable=false)
    @ManyToOne
    private Product product;

    public Product getProduct() {
        return product;
    }

    public void setProduct(Product product) {
        this.product = product;
    }

    @Basic(optional = false)
    @Column(name = "request", nullable = false)
    private int request;

    public CartItem() {
    }

    public CartItem(Integer idUser, Integer idProduct, int request) {
        this.idUser = idUser;
        this.idProduct = idProduct;
        this.request = request;
    }

    public Integer getIdProduct() {
        return idProduct;
    }

    public void setIdProduct(Integer idProduct) {
        this.idProduct = idProduct;
    }

    public int getRequest() {
        return request;
    }

    public void setRequest(int request) {
        this.request = request;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        Integer key = new Integer(idUser.intValue()+product.getIdProduct().intValue());
        hash += (key != null ? key.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CartItem)) {
            return false;
        }
        CartItem other = (CartItem) object;
        Integer keyThis = new Integer(idUser.intValue()+product.getIdProduct().intValue());
        Integer keyOther = new Integer(other.idUser.intValue()+other.product.getIdProduct().intValue());
        if ((keyThis == null && keyOther != null) || (keyThis != null && !keyThis.equals(keyOther))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "it.electronicshop.ejb.db.Cart[idCUser=" + idUser + "]";
    }

}
