/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.electronicshop.ejb.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 *
 * @author boymixli
 */
@Entity
@Table(name = "product", catalog = "electronicshop", schema = "", uniqueConstraints = {@UniqueConstraint(columnNames = {"nameProduct"})})
@NamedQueries({
    @NamedQuery(name = "it.electronicshop.ejb.entities.Product.findAll", query = "SELECT p FROM Product p"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Product.findByIdProduct", query = "SELECT p FROM Product p WHERE p.idProduct = :idProduct"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Product.findByNameProduct", query = "SELECT p FROM Product p WHERE p.nameProduct = :nameProduct"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Product.findByDescProduct", query = "SELECT p FROM Product p WHERE p.descProduct = :descProduct"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Product.findByPrize", query = "SELECT p FROM Product p WHERE p.prize = :prize"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Product.findByQuantity", query = "SELECT p FROM Product p WHERE p.quantity = :quantity"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Product.findByIdType", query = "SELECT p FROM Product p WHERE p.idType = :idType")})



public class Product implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "idProduct", nullable = true)
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private Integer idProduct;
    @Basic(optional = false)
    @Column(name = "nameProduct", nullable = false, length = 100)
    private String nameProduct;
    @Basic(optional = false)
    @Column(name = "descProduct", nullable = false, length = 300)
    private String descProduct;
    @Basic(optional = false)
    @Column(name = "prize", nullable = false)
    private float prize;
    @Basic(optional = false)
    @Column(name = "quantity", nullable = false)
    private int quantity;
    @Basic(optional = false)
    @Column(name = "idType", nullable = false)
    private Integer idType;

    @JoinColumn(name = "idType", referencedColumnName= "idType", insertable=false, updatable=false)
    @ManyToOne
    private Producttype productType;

    public Producttype getProductType() {
        return productType;
    }

    public void setProductType(Producttype productType) {
        this.productType = productType;
    }

    public Product() {
    }

    public Product(Integer idProduct) {
        this.idProduct = idProduct;
    }

    public Product(Integer idProduct, String nameProduct, String descProduct, float prize, int quantity, Integer idType) {
        this.idProduct = idProduct;
        this.nameProduct = nameProduct;
        this.descProduct = descProduct;
        this.prize = prize;
        this.quantity = quantity;
        this.idType = idType;
    }

    public Integer getIdProduct() {
        return idProduct;
    }

    public void setIdProduct(Integer idProduct) {
        this.idProduct = idProduct;
    }

    public String getNameProduct() {
        return nameProduct;
    }

    public void setNameProduct(String nameProduct) {
        this.nameProduct = nameProduct;
    }

    public String getDescProduct() {
        return descProduct;
    }

    public void setDescProduct(String descProduct) {
        this.descProduct = descProduct;
    }

    public float getPrize() {
        return prize;
    }

    public void setPrize(float prize) {
        this.prize = prize;
    }

    public int getQuantity() {
        return quantity;
    }

    public void setQuantity(int quantity) {
        this.quantity = quantity;
    }

    public Integer getIdType() {
        return idType;
        //return 1;
    }

    public void setIdType(Integer idType) {
        this.idType = idType;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idProduct != null ? idProduct.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof Product)) {
            return false;
        }
        Product other = (Product) object;
        if ((this.idProduct == null && other.idProduct != null) || (this.idProduct != null && !this.idProduct.equals(other.idProduct))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "it.electronicshop.ejb.db.Product[idProduct=" + idProduct + "]";
    }

}
