/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.electronicshop.ejb.entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import static javax.persistence.CascadeType.ALL;

/**
 *
 * @author boymixli
 */
@Entity
@Table(name = "producttype", catalog = "electronicshop", schema = "", uniqueConstraints = {@UniqueConstraint(columnNames = {"nameType"})})
@NamedQueries({
    @NamedQuery(name = "it.electronicshop.ejb.entities.Producttype.findAll", query = "SELECT p FROM Producttype p"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Producttype.findByIdType", query = "SELECT p FROM Producttype p WHERE p.idType = :idType"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Producttype.findByNameType", query = "SELECT p FROM Producttype p WHERE p.nameType = :nameType"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.Producttype.findByDescriptionType", query = "SELECT p FROM Producttype p WHERE p.descriptionType = :descriptionType")})

public class Producttype implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "idType", nullable = true)
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private Integer idType;
    @Basic(optional = false)
    @Column(name = "nameType", nullable = false, length = 45)
    private String nameType;
    @Column(name = "descriptionType", length = 300)
    private String descriptionType;

    @OneToMany(cascade = ALL, mappedBy = "productType")
    protected List<Product> products;
    public List<Product> getProducts() {
        return products;
    }

    public void setProducts(List<Product> products) {
        this.products = products;
    }

    public void addProducts(Product product) {
        this.getProducts().add(product);
    }

    public void dropProducts(Product product) {
        this.getProducts().remove(product);
    }

    public Producttype() {
    }

    public Producttype(Integer idType) {
        this.idType = idType;
    }

    public Producttype(Integer idType, String nameType, String descriptionType) {
        this.idType = idType;
        this.nameType = nameType;
        this.descriptionType = descriptionType;
    }

    public Integer getIdType() {
        return idType;
    }

    public void setIdType(Integer idType) {
        this.idType = idType;
    }

    public String getNameType() {
        return nameType;
    }

    public void setNameType(String nameType) {
        this.nameType = nameType;
    }

    public String getDescriptionType() {
        return descriptionType;
    }

    public void setDescriptionType(String descriptionType) {
        this.descriptionType = descriptionType;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idType != null ? idType.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof Producttype)) {
            return false;
        }
        Producttype other = (Producttype) object;
        if ((this.idType == null && other.idType != null) || (this.idType != null && !this.idType.equals(other.idType))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "it.electronicshop.ejb.db.Producttype[idType=" + idType + "]";
    }

}
