/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.electronicshop.ejb.entities;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import static javax.persistence.CascadeType.ALL;

/**
 *
 * @author boymixli
 */
@Entity
@Table(name = "userClient", catalog = "electronicshop", schema = "", uniqueConstraints = {@UniqueConstraint(columnNames = {"name"})})
@NamedQueries({
    @NamedQuery(name = "it.electronicshop.ejb.entities.UserClient.findAll", query = "SELECT u FROM UserClient u"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.UserClient.findByIdUser", query = "SELECT u FROM UserClient u WHERE u.idUser = :idUser"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.UserClient.findByName", query = "SELECT u FROM UserClient u WHERE u.name = :name"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.UserClient.findByPassword", query = "SELECT u FROM UserClient u WHERE u.password = :password"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.UserClient.findAdminUser", query = "SELECT object(o) FROM UserClient as o WHERE o.name = :name AND o.password = :password AND o.isAdmin = 1"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.UserClient.findClientUser", query = "SELECT object(o) FROM UserClient as o WHERE o.name = :name AND o.password = :password AND o.isAdmin != 1"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.UserClient.findUserByPass", query = "SELECT o FROM UserClient as o WHERE o.name = :name AND o.password = :password"),
    @NamedQuery(name = "it.electronicshop.ejb.entities.UserClient.findByIsAdmin", query = "SELECT u FROM UserClient u WHERE u.isAdmin = :isAdmin")})

public class UserClient implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "idUser", nullable = true)
    @GeneratedValue(strategy=GenerationType.IDENTITY)
    private Integer idUser;


    @OneToMany(cascade = ALL, mappedBy = "client")
    protected List<CartItem> cartItems;
    public List<CartItem> getCartItems() {
        return cartItems;
    }

    public void setCartItems(List<CartItem> cartItems) {
        this.cartItems = cartItems;
    }

    public void addCartItems(CartItem cartItem) {
        this.getCartItems().add(cartItem);
    }

    public void dropCartItems(CartItem cartItem) {
        this.getCartItems().remove(cartItem);
    }
    
    @Basic(optional = false)
    @Column(name = "name", nullable = false, length = 45)
    private String name;
    @Basic(optional = false)
    @Column(name = "password", nullable = false, length = 15)
    private String password;
    @Basic(optional = false)
    @Column(name = "is_admin", nullable = false)
    private int isAdmin;

    public UserClient() {
    }

    public UserClient(Integer idUser) {
        this.idUser = idUser;
    }

    public UserClient(Integer idUser, String name, String password, int isAdmin) {
        this.idUser = idUser;
        this.name = name;
        this.password = password;
        this.isAdmin = isAdmin;
    }

    public Integer getIdUser() {
        return idUser;
    }

    public void setIdUser(Integer idUser) {
        this.idUser = idUser;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public int getIsAdmin() {
        return isAdmin;
    }

    public void setIsAdmin(int isAdmin) {
        this.isAdmin = isAdmin;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (idUser != null ? idUser.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        if (!(object instanceof UserClient)) {
            return false;
        }
        UserClient other = (UserClient) object;
        if ((this.idUser == null && other.idUser != null) || (this.idUser != null && !this.idUser.equals(other.idUser))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "it.electronicshop.ejb.db.UserClient[idUser=" + idUser + "]";
    }

}
