<%-- 
    Document   : catalog.jsp
    Created on : Jun 9, 2009, 12:04:14 PM
    Author     : developer
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page import="
    it.electronicshop.web.controller.setup.Setup,
    it.electronicshop.ejb.beans.cartControllerRemote,
    it.electronicshop.ejb.util.UserClientDetails"%>

 <%!
    public void jspInit() {
        try {
            Setup setup = new Setup(this);

        } catch (Exception ex) {
            System.out.println("Carrello non caricato: "+
                    ex.getMessage());
        }
    }
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Carrello</title>
        <link rel="stylesheet" type="text/css" href="<%=request.getContextPath()%>/resources/css/stylesheet.css" />
        <script>
            function delProductInCart(idProduct)
            {
                document.execute.product.value = idProduct;
                document.execute.action = "<%=request.getContextPath()%>/product/delPFromCart?from=cart";
                document.execute.submit();
            }
            function less(idProduct, requeOld)
            {
                if(requeOld > 1)
                {
                    document.execute.product.value = idProduct;
                    document.execute.action = "<%=request.getContextPath()%>/cart/less";
                    document.execute.submit();
                }
            }
            function more(idProduct)
            {
                document.execute.product.value = idProduct;
                document.execute.action = "<%=request.getContextPath()%>/cart/more";
                document.execute.submit();
            }
            function emptyCart()
            {
                if(confirm("Sei sicuro di voler svuotare il carrello ?"))
                {
                    document.execute.action = "<%=request.getContextPath()%>/cart/clean";
                    document.execute.submit();
                }
            }
            function saveCart()
            {
                document.execute.action = "<%=request.getContextPath()%>/cart/save";
                document.execute.submit();
            }
            function removeCart()
            {
             if(confirm("Sei sicuro di voler eliminare il carrello ?"))
                {
                    document.execute.action = "<%=request.getContextPath()%>/cart/remove";
                    document.execute.submit();
                }
            }
            function buy()
            {
                document.execute.action = "<%=request.getContextPath()%>/cart/buy";
                document.execute.submit();
            }
        </script>
    </head>
    <body>
        <div id="container">
            <jsp:include page="header.jsp" />
            <div id="main">
                <c:if test="${fn:length(requestScope['body']) > 0}">
                    <div class="infoMessage">
                        ${requestScope['body']}
                    </div>
                </c:if>
                <c:if test="${fn:length(requestScope['body']) <=  0}">
                <form name="execute" action="" method="POST">
                    <input type="hidden" name="product" value="-1" />
                    <c:if test="${fn:length(requestScope['productsC']) > 0}">
                        <div id="staticMain">                                
                                <a href="javascript:emptyCart()">Svuota Carrello <img src="<%=request.getContextPath()%>/resources/images/trash.png" width="16" height="16" alt="Svuota Carrello"/></a> |
                                <a href="javascript:saveCart()">Salva Carrello <img src="<%=request.getContextPath()%>/resources/images/save.png" width="16" height="16" alt="Salva Carrello"/></a> |
                                <a href="javascript:removeCart()">Elimina ultimo carrello salvato <img src="<%=request.getContextPath()%>/resources/images/cancel.png" width="16" height="16" alt="Elimina ultimo carrello salvato"/></a> |
                                <a href="javascript:buy()">Compra <img src="<%=request.getContextPath()%>/resources/images/buy.png" width="16" height="16" alt="Compra"/></a> | Totale: <fmt:formatNumber value="${requestScope['importC']}" type="currency" currencyCode="EUR" pattern="€ ####.00" currencySymbol="EUR"/>
                        </div>
                        <div id="cart">
                            <table border="1">
                                <thead>
                                    <tr>
                                        <th border="0"></th>
                                        <th>Nome</th>
                                        <th>Descrizione</th>
                                        <th>Prezzo</th>
                                        <th>Richiesta ( Disponibilità )</th>
                                        <th>Tipo prodotto</th>
                                    </tr>
                                </thead>
                                <tbody>
                                   <c:set var="itempC" value="1" />
                                   <c:forEach var="productC" begin="0" items="${requestScope['productsC']}">
                                   <c:set var="product" value="${productC.product}" />
                                   <c:if test="${itempC % 2 == 0}">
                                       <c:set var="classStyle" value="pair" />
                                   </c:if>
                                   <c:if test="${itempC % 2 != 0}">
                                       <c:set var="classStyle" value="disp" />
                                   </c:if>
                                   <c:set var="itempC" value="${itempC + 1}" />
                                    <input type="hidden" name="productID" value="${product.idProduct}" />
                                    <input type="hidden" name="dispo_${product.idProduct}" value="${product.quantity}" />
                                    <tr class="${classStyle}">
                                        <td style="text-align: center" width="70px">
                                        <a href="javascript:delProductInCart(${product.idProduct})"><img src="<%=request.getContextPath()%>/resources/images/cancel.png" width="16" height="16" alt="Rimuovi da Carrello"/></a>
                                        <c:if test="${product.quantity <= 0}">
                                            Prodotto FINITO
                                        </c:if>
                                        </td>
                                        <td>${product.nameProduct}</td>
                                        <td>${product.descProduct}</td>
                                        <td style="text-align: center" width="70px"><fmt:formatNumber value="${product.prize}" type="currency" currencyCode="EUR" pattern="€ ####.00" currencySymbol="EUR"/></td>
                                        <td style="text-align: center">
                                            <c:if test="${product.quantity > 0}">
                                                <input readonly name="request_${product.idProduct}" style="width: 30px" maxlength="3" type="text" value="${productC.request}" />
                                                <a href="javascript:more(${product.idProduct})">
                                                    <img src="<%=request.getContextPath()%>/resources/images/cart_add.png" width="16" height="16" alt="Aggiungi"/></a>
                                                <a href="javascript:less(${product.idProduct},${productC.request})">
                                                    <img src="<%=request.getContextPath()%>/resources/images/cart_delete.png" width="16" height="16" alt="Togli"/></a> (${product.quantity})
                                            </c:if>
                                        </td>
                                        <td style="text-align: center">${product.ptD.nameType}</td>
                                    </tr>
                                   </c:forEach>
                                </tbody>
                            </table>
                        </div>
                    </c:if>
                    <c:if test="${fn:length(requestScope['productsC']) <= 0}">
                        <div id="staticMain">
                            Non ci sono prodotti caricati nel carrello
                        </div>
                    </c:if>
                </form>
                </c:if> 
           </div>
           <jsp:include page="footer.jsp" />
        </div>
   </body>
</html>
