/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it.electronicshop.web.controller;

import it.electronicshop.ejb.beans.cartControllerRemote;
import it.electronicshop.ejb.beans.requestRemote;
import it.electronicshop.ejb.util.CartDetails;
import it.electronicshop.ejb.util.CartItemDetails;
import it.electronicshop.ejb.util.ProductDetails;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import javax.ejb.CreateException;
import javax.naming.NamingException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 *
 * @author boymixli
 */
public class CartC extends Controller {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, NamingException, CreateException {
        try {
            cartCR = (cartControllerRemote) getServletContext().getAttribute("cart");
            req = (requestRemote) getServletContext().getAttribute("req");
            nextPage =  "/cart/main";
            errorMsg = "";
            generalMsg = "";
            String body = "";

            if(cartCR.getUcd() == null)
            {
                //user not loggin
                errorMsg = "Utente non loggato";
                nextPage = "/index.jsp";
                throw new Exception(errorMsg);
            }

            String uri = request.getRequestURI();
            String command = uri.substring(uri.indexOf("/cart/")+1);
            String[] tmpS = command.split("/");
            String method = tmpS[1];

            String pt = "-1";
            if(request.getParameter("productType") != null)
            {
                pt = (String) request.getParameter("productType");
            }
            if(request.getAttribute("productType") != null)
            {
                pt = (String) request.getAttribute("productType");
            }
            if(request.getParameter("generalMsg") != null)
            {
                generalMsg = (String) request.getParameter("generalMsg");
            }
            if(request.getAttribute("generalMsgLong") != null)
            {
                generalMsg = (String) request.getAttribute("generalMsgLong");
            }
            if(request.getAttribute("body") != null)
            {
                body = (String) request.getAttribute("body");
            }

            request.setAttribute("productType", pt);
            if(method.equals("main"))
            {                
                nextPage =  "/cart.jsp";
                List<CartItemDetails> productsC = null;
                if(cartCR.getProductsFromCart() != null && cartCR.getProductsFromCart().size() > 0)
                {
                    productsC = cartCR.getProductsFromCart();
                    float importC = 0;
                    for (CartItemDetails cdi : productsC) {
                        
                        importC += cdi.getProduct().getPrize()*cdi.getRequest();
                    }
                    request.setAttribute("importC", importC);
                    request.setAttribute("productsC", productsC);
                }
            }
            else if(method.equals("load")){
                CartDetails c = req.findCartByClient(cartCR.getUcd().getIdUser());
                if(c != null && c.getItems().size() > 0)
                {
                    cartCR.loadCart(c);
                    generalMsg="Carrello caricato";
                }
                else
                {
                    errorMsg = "Attenzione non sono presenti carrelli salvati";
                }
            }
            else if(method.equals("save")){                
                req.editCart(cartCR.getUcd().getCart());
                generalMsg="Carrello salvato";
                nextPage =  "/cart/main?generalMsg="+generalMsg;
            }
            else if(method.equals("remove")){
                req.removeCart(cartCR.getUcd().getIdUser());
                generalMsg="Carrello eliminato";
                nextPage =  "/cart/clean?generalMsg="+generalMsg;
            }
            else if(method.equals("more")){
                Integer productId = new Integer(request.getParameter("product"));
                ProductDetails pDB = req.findProduct(productId);
                CartItemDetails cd =  cartCR.getProductCartById(productId);
                if(pDB.getQuantity() < cd.getRequest()+1)
                {
                    generalMsg="Attenzione " +pDB.getNameProduct()+ " non disponibile nella quantità richiesta, quantità attuale: "+pDB.getQuantity();
                }
                else
                {
                    cd.setRequest(cd.getRequest()+1);
                    cartCR.setProductCartById(cd);
                    generalMsg="Quantità prodotto aumentata";
                }
            }
            else if(method.equals("less")){
                Integer productId = new Integer(request.getParameter("product"));
                ProductDetails pDB = req.findProduct(productId);
                CartItemDetails cd =  cartCR.getProductCartById(productId);
                if(pDB.getQuantity() < cd.getRequest()-1)
                {
                    generalMsg="Attenzione " +pDB.getNameProduct()+ " non disponibile nella quantità richiesta, quantità attuale: "+pDB.getQuantity();
                }
                else
                {
                    cd.setRequest(cd.getRequest()-1);
                    cartCR.setProductCartById(cd);
                    generalMsg="Quantità prodotto diminuita";
                }
            }
            else if(method.equals("buy")){
                List<String> messages = new LinkedList();
                float imp = 0;
                for(CartItemDetails cd : cartCR.getProductsFromCart())
                {
                    ProductDetails pDB = req.findProduct(cd.getProduct().getIdProduct());
                    if(pDB.getQuantity() < cd.getRequest())
                    {
                        messages.add("Attenzione Prodotto: "+pDB.getNameProduct()+" non considerato, non più disponibile nella quantità richiesta");
                    } else 
                    {   
                        if(pDB.getPrize() != cd.getProduct().getPrize())
                        {
                            messages.add("Attenzione prezzo Prodotto: "+pDB.getNameProduct()+" variato da: "+ cd.getProduct().getPrize() + " a "+ pDB.getPrize());
                        }
                        pDB.setQuantity(pDB.getQuantity() -  cd.getRequest());
                        req.editProduct(pDB);
                        float costP = pDB.getPrize() * cd.getRequest();
                        imp += costP;
                        messages.add("Prodotto: "+pDB.getNameProduct()+" Richiesti: "+cd.getRequest() + " + €"+ costP);                        
                    }
                }
                messages.add("Totale importo €"+ imp);
                messages.add("Grazie per aver pagato");
                for (String msg : messages) {
                    generalMsg += "<br />"+msg;
                }
                nextPage =  "/cart/clean";
                request.setAttribute("body", generalMsg);
            }
            else if(method.equals("clean")){
                cartCR.cleanCart();
                if(generalMsg.equals(""))
                {
                    generalMsg ="Carrello svuotato";
                }
            }
        }
        catch (Exception e)
        {
            errorMsg = "Attenzione si è verificato il seguente errore: "+e.getMessage();
        }

        RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(nextPage);
        request.setAttribute("errorMessage", errorMsg);
        request.setAttribute("generalMsg", generalMsg);
        dispatcher.forward(request,response);
    }
}
