﻿--
-- Create schema electronicshop
--
DROP DATABASE IF EXISTS `electronicshop`;
CREATE DATABASE `electronicshop`;
USE `electronicshop`;


-- Tables
DROP TABLE IF EXISTS `product`;
CREATE TABLE `product` (
  `idProduct` int(10) unsigned NOT NULL auto_increment,
  `nameProduct` varchar(100) NOT NULL,
  `descProduct` varchar(300) NOT NULL,
  `prize` float NOT NULL,
  `quantity` int(10) unsigned NOT NULL,
  `idType` int(10) unsigned NOT NULL REFERENCES `productType`(`idType`),
  PRIMARY KEY  (`idProduct`),
  UNIQUE(`nameProduct`),
  KEY `FK_TypeP` (`idType`) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `productType`;
CREATE TABLE `producttype` (
  `idType` int(10) unsigned NOT NULL auto_increment,
  `nameType` varchar(45) NOT NULL,
  `descriptionType` varchar(300),
  PRIMARY KEY (`idType`),
  UNIQUE (`nameType`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `userClient`;
CREATE TABLE `userClient` (
  `idUser` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(45) NOT NULL,
  `password` varchar(15) NOT NULL,
  `is_admin` int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`idUser`),
  UNIQUE(`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `cart`;
CREATE TABLE `cart` (
  `idCart` int(10) unsigned NOT NULL auto_increment,
  `idUser` int(10) unsigned NOT NULL REFERENCES userClient (idUser),
  `idProduct` int(10) unsigned NOT NULL REFERENCES product (idProduct),
  `request` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`idCart`),
  KEY `FK_UserId` (`idUser`),
  KEY `FK_ProductId` (`idProduct`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- User
CREATE USER 'electuser'@'localhost' IDENTIFIED BY 'elect_user';
GRANT ALL PRIVILEGES ON electronicshop.* TO 'electuser'@'localhost' WITH GRANT OPTION;

FLUSH PRIVILEGES;
